<template>
  <div id="lecture_item_setting" class="bt-container">
    <h2>
      {{ $t("ITEM.ORDER_SET") }}
      <!--아이템 순서 설정 -->
    </h2>

    <!-- testMode false: 그룹간 순서 유지 true : 그룹간 순서 셔플 -->
    <el-switch
      v-if="lectureType !== 0"
      v-model="testMode"
      :active-text="$t('ITEM.SHUFFLE_ORDER')"
      :inactive-text="$t('ITEM.MAINTAIN_ORDER')"
      active-color="#ff4949"
      inactive-color="#13ce66"
    />

    <el-popover
      v-if="lectureType !== 0"
      style="position: relative; left: 15px; top: 3px"
      placement="bottom-start"
      width="600"
      trigger="hover"
    >
      <el-table :data="modeInfo">
        <el-table-column
          width="150"
          property="title"
          :label="$t('ITEM.MODE')"
        ></el-table-column>
        <el-table-column
          width="450"
          property="content"
          :label="$t('ITEM.EXP')"
        ></el-table-column>
      </el-table>
      <i class="el-icon-question fa-lg" slot="reference"></i>
    </el-popover>

    <div style="text-align: right">
      <el-button type="primary" @click="submitSetting()">{{
        $t("ITEM.SET_FINISH")
      }}</el-button>
      <el-button
        @click="goBack()"
        style="margin-left: 10px; margin-right: 5px"
        >{{ $t("BOARD.BACK") }}</el-button
      >
    </div>
    <div style="height: 30px" />

    <el-row>
      <el-col :span="18">
        <!-- 그룹하고 그룹 미지정 사이의 거리 -->

        <div class="itemBoard">
          <ul
            class="groupList"
            v-for="(item, index) in itemGroup"
            :key="index"
            :data="item"
            draggable="true"
            @dragstart="dragStartGroup(index)"
            @dragend="dragEndGroup()"
            @drop="dropGroup(index)"
            @dragover.prevent
          >
            <p style="font-size: 20px; margin-top: 0px; margin-bottom: 10px">
              {{ $t("ITEM.GROUP") }} {{ index + 1 }}
              <!-- 그룹1, 그룹2라고 적혀있는 글자의 크기 -->

              <el-popover
                v-if="index === 0"
                style="position: relative; left: 5px; top: 1px"
                placement="bottom-start"
                width="600"
                trigger="hover"
              >
                <el-table :data="notice2" v-if="lectureType == 0">
                  <el-table-column
                    width="150"
                    property="title"
                    :label="$t('ITEM.MODE')" 
                  ></el-table-column>
                  <el-table-column
                    width="450"
                    property="content"
                    :label="$t('ITEM.EXP')"
                  ></el-table-column>
                </el-table>
                <el-table :data="notice6" v-if="lectureType != 0">
                  <el-table-column
                    width="150"
                    property="title"
                    :label="$t('ITEM.MODE')" 
                  ></el-table-column>
                  <el-table-column
                    width="450"
                    property="content"
                    :label="$t('ITEM.EXP')"
                  ></el-table-column>
                </el-table>                
                <i
                  class="el-icon-question fa-lg"
                  slot="reference"
                  style="font-size: 22px"
                ></i>




              </el-popover>

              <el-button size="mini" @click="resetGroup(index)">{{
                $t("ITEM.RESET")
              }}</el-button>
            </p>

            <!-- item.seq : 유인강의만 해당된다. 무인강의는 바로 출력 -->
            <el-col :span="item.seq ? 15 : 3">
              <!-- 유인 항목에서 순차활성을 기록하면 시간을 입력하는 창의 위치 조절 -->
              <li
                class="itemList"
                v-for="(item2, index2) in item.list"
                :key="index2"
                draggable="true"
                @dragstart="dragStart(item, index, index2)"
                @dragend="dragEnd()"
                @drop="drop(index, index2)"
                @dragover.prevent
              >
                {{ item2.name }}
                <!-- 그룹 배너에서 아이템 이름 표시해주는 부분-->
              </li>
              <el-switch
                v-model="item.seq"
                v-if="lectureType === 0"
                :active-text="$t('ITEM.SEQUENCE')"
                :inactive-text="$t('ITEM.SAME_TIME')"
                active-color="#f56c6c"
                inactive-color="#4ecea8"
              />
              <div style="height: 10px" />
              <el-switch
                v-model="item.shuffle"
                :active-text="$t('ITEM.SHUFFLE_GROUP')"
                :inactive-text="$t('ITEM.FIX_ORDER')"
                active-color="#f56c6c"
                inactive-color="#4ecea8"
              />
              <!-- shufflePopUp 함수 주석처리됨 ㅇㅇ -->
               <!--<el-switch v-model="item.shuffle"
                :active-text="$t('ITEM.SHUFFLE_GROUP')" :inactive-text="$t('ITEM.FIX_ORDER')"
                active-color="#f56c6c" inactive-color="#4ecea8"
                @change="shufflePopUp(item, index)"
              /> -->

              <!-- lectureType이 0이 아니면 했기 때문에 유인강의는 아니다. -->
              <!-- 그룹 밑에 있는 시간을 설정하는 부분 -->
              <p v-if="lectureType !== 0" style="font-size: 15px">
                {{ $t("ITEM.GRP_ACT_TIME") }}
              </p>
              <el-time-picker
                v-if="lectureType !== 0"
                v-model="item.time"
                placeholder="hh : mm : ss"
                style="width: 150px; margin-left: 20px"
                :default-value="item.time"
              />
            </el-col>

            <!--유인 강의 시간 설정 -->

            <el-col v-if="item.seq === true" :span="3">
              <li v-for="(item2, index2) in item.list" :key="index2">
                <el-time-picker
                  v-model="item2.duringTime"
                  placeholder="hh:mm:ss"
                  style="width: 120px"
                  default-value="0"
                />
                <div style="height: 10px" />
              </li>
              <!--el-time-picker v-if="lectureType === 0 && item.seq === true"
                v-model="item.time" placeholder="hh : mm : ss"
                style="width: 150px; margin-left: 20px;"
                :default-value="item.time"
                :disabled="false"
              /-->
            </el-col>
          </ul>
          <!-- 그룹 미지정에서 새그룹으로 편성하면서 나오는 그룹페이지 -->
          <!-- dragover.prevent 를 입력하지 않으면 새로운 노드로 값을 전달하지 않는다. -->
          <ul class="groupList" v-if="ifDragStart">
            <p style="font-size: 20px; margin-top: 0px; margin-bottom: 10px">
              {{ $t("ITEM.NEW_GROUP") }}
            </p>
            <li class="semiItemList" @drop="newGroup()" @dragover.prevent>
              {{ $t("ITEM.INTO_NEW") }}
            </li>
          </ul>
        </div>
      </el-col>

      <el-col :span="6">
        <div class="noItemBoard">
          <ul class="noGroupList">
            <p style="font-size: 20px; margin-top: 0px; margin-bottom: 10px">
              {{ $t("ITEM.UNDE") }}
              <el-popover
                style="position: relative; left: 10px; top: 1px"
                placement="bottom-start"
                width="600"
                trigger="hover"
              >
                <el-table :data="notice3">
                  <el-table-column
                    width="150"
                    property="title"
                    :label="$t('ITEM.MODE')"
                  ></el-table-column>
                  <el-table-column
                    width="450"
                    property="content"
                    :label="$t('ITEM.EXP')"
                  ></el-table-column>
                </el-table>
                <i
                  class="el-icon-question fa-lg"
                  slot="reference"
                  style="font-size: 22px"
                ></i>
              </el-popover>
            </p>
            <li
              class="itemList"
              v-for="(item, index) in noItemGroup"
              :key="index"
              draggable="true"
              @dragstart="dragStartFromNo(index)"
              @dragend="dragEnd"
              @drop="dropToNo()"
              @dragover.prevent
            >
              {{ item.name }}
            </li>
            <li
              v-if="noItemGroup.length === 0"
              class="semiItemList"
              @drop="dropToNo()"
              @dragover.prevent
            >
              {{ $t("ITEM.EXCLUDE") }}
            </li>
          </ul>
        </div>
      </el-col>
    </el-row>
  </div>
</template>




<script>
import deepCopy from "deep-copy";
import draggable from "vuedraggable";
import { mapMutations } from "vuex";
import lectureItemService from "../../services/lectureItemService";
import lectureService from "../../services/lectureService";

export default {
  name: "LectureItemSetting",
  components: {
    draggable,
  },
  data() {
    return {
      lectureType: "", // 0-유인 1-무인단체 2-무인개인
      testMode: false, // 그룹 간 순서 유지면 false, 그룹 간 순서 셔플이면 true
      itemGroup: [],
      noItemGroup: [],
      originGroup: -1,
      originNum: -1,
      dragGroup: -1,
      moveItem: null, // 옮길 아이템
      ifDragStart: false, // 아이템 드래그 시작하면 true, 이 외에는 false
      shuffleDialogVisible: false,
      shuffleItemGroup: [], // 그룹 내 셔플용 array
      shuffleNoItemGroup: [], // 그룹 내 셔플의 미지정 array
      shuffleOriginGroup: -1,
      shuffleOriginNum: -1,
      shuffleDragGroup: -1,
      shuffleMoveItem: null,
      shuffleIfDragStart: false,
      shuffleItemIndex: 0,
      shuffleItem: null,
      shuffleSettingSaved: false,
      shuffleGroupTime: null,
      timeDialogVisible: false, // 그룹 활성화 시간 확인용
      savedShuffleItemGroup: [],

      modeInfo: [
        {
          //아이템 순서 설정 밑에 물음표에 들어가는 테이블.
          title: this.$t("ITEM.MAINTAIN_ORDER"),
          content: this.$t("HELP.SET_ITEM_ORDER1"),
        },
        {
          title: this.$t("ITEM.SHUFFLE_ORDER"),
          content: this.$t("HELP.SET_ITEM_ORDER2"),
        },
      ],

      notice2: [
        {
          //그룹1 옆에 물음표에 들어가는 테이블
          title: this.$t("ITEM.EXPLAIN_ITEM"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER3"),
        },
        {
          title: this.$t("ITEM.EXPLAIN_CHNG_ORD_GRP"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER4"),
        },
        {
          title: this.$t("ITEM.EXPLAIN_CHNG_ORD_ITEM"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER5"),
        },
        {
          title: this.$t("ITEM.EXPLAIN_WORK_TOGE"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER6"),
        },
        {
          title: this.$t("ITEM.EXPLAIN_WORD_STA"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER7"),
        },
        {
          title: this.$t("ITEM.FIX_ORDER"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER8"),
        },
        {
          title: this.$t("ITEM.SHUFFLE_GROUP"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER9"),
        },
      ],

      notice3: [
        {
          //그룹 미지정 옆에 물음표에 들어가는 테이블
          title: this.$t("ITEM.UNDE"),
          content: this.$t("HELP.SET_ITEM_ORDER8"),
        },
      ],

      notice4: [
        {
          //아이템 소그룹. //미구현
          title: this.$t("ITEM.SMA_GRP"),
          content: this.$t("HELP.SET_ITEM_ORDER9"),
        },
      ],

      notice5: [
        {
          //소그룹 미지정 //미구현
          title: this.$t("ITEM.SMA_UNDE"),
          content: this.$t("HELP.SET_ITEM_ORDER10"),
        },
      ],
       notice6: [
        {
          //그룹1 옆에 물음표에 들어가는 테이블
          title: this.$t("ITEM.EXPLAIN_ITEM"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER3"),
        },
        {
          title: this.$t("ITEM.EXPLAIN_CHNG_ORD_GRP"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER4"),
        },
        {
          title: this.$t("ITEM.EXPLAIN_CHNG_ORD_ITEM"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER5"),
        },
        {
          title: this.$t("ITEM.FIX_ORDER"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER8"),
        },
        {
          title: this.$t("ITEM.SHUFFLE_GROUP"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER9"),
        },
        {
          title: this.$t("ITEM.EXPLAIN_SET_TIME"),
          content: this.$t("HELP.EXPLAIN_SET_ITEM_ORDER10"),
        },
      ],

    };
  },

  async created() {
    const vm = this;
    // lecture type === 0-유인 1-무인단체 2-무인개인
    const lecture = await lectureService.getLecture({
      lectureId: vm.lectureId,
    });
    vm.lectureType = lecture.data.type;
    const itemList = lecture.data.lecture_items;

    // 테스트모드인지 일반모드인지 //그룹간 순서 유지=false , 그룹 간 셔플 지정= true.
    vm.testMode = lecture.data.test_mode;

    // 아이템 순서대로 정렬
    itemList.sort((a, b) => {
      const aItemSequence = Number(a.sequence);
      const bItemSequence = Number(b.sequence);
      return aItemSequence - bItemSequence;
    });

    // 유형 수정
    itemList.forEach((x) => {
      x.ifGroup = false; // eslint-disable-line
      // 아이템 그룹 초기화
      if (x.type === 0) {
        x.type = "문항"; // eslint-disable-line
      } else if (x.type === 1) {
        x.type = "설문"; // eslint-disable-line
      } else if (x.type === 2) {
        x.type = "실습"; // eslint-disable-line
      } else if (x.type === 3) {
        x.type = "토론"; // eslint-disable-line
      } else if (x.type === 4) {
        x.type = "자료"; // eslint-disable-line
      } else if (x.type === 5) {
        x.type = "코딩"; // eslint-disable-line
      }
    });
    // 아이템 그룹, 연결 리스트 가져오기
    const grp = await lectureItemService.showGroup({
      lectureId: vm.lectureId,
    });
    const smGrp = await lectureItemService.showSmallGroup({
      lectureId: vm.lectureId,
    });
    const itm = await lectureItemService.showItem({
      lectureId: vm.lectureId,
    });
    const seq = await lectureItemService.showConnection({
      lectureId: vm.lectureId,
    });

    // 그룹에 포함된 아이템들
    grp.data.list.forEach((x) => {
      let f1 = false;
      const durings = [];
      const groupA = {};
      groupA.smallGroup = [];
      groupA.list = [];
      groupA.seq = false; // F - 동시활성 / T - 순차활성
      groupA.shuffle = false; // F - 순서고정 / T - 셔플링
      // if_small_group: 0 -동시활성 / 1 -순차활성 & 셔플링 / 2 - 순차활성 & 순서고정
      if (vm.lectureType === 0 && x.if_small_group !== null) {
        // 유인 강의 순차활성 - smallGroup

        groupA.seq = true;
        if (x.if_small_group === 1) {
          // 순차활성 & 셔플링
          groupA.shuffle = true;
        } else if (x.if_small_group === 2) {
          // 순차활성 & 순서고정
          groupA.shuffle = false;
        }

        const smGrpIds = x.list_ids;
        let tmp404 = 0;
        smGrpIds.forEach((y) => {
          smGrp.data.group.forEach((z) => {
            if (parseInt(y, 10) === z.lecture_item_small_group_id) {
              //y를 10진수로 변경
              f1 = true;

              itm.data.items.forEach((w) => {
                if (
                  parseInt(z.linked_small_group, 10) === w.lecture_item_list_id
                ) {
                  itemList.forEach((v) => {
                    if (w.item_id === v.lecture_item_id) {
                      v.ifGroup = true;
                      v.during = z.during;
                      const hh = parseInt(v.during / (60 * 60));
                      const mm = parseInt((v.during - 60 * 60 * hh) / 60);
                      const ss = v.during - 60 * 60 * hh - 60 * mm;
                      v.duringTime = new Date(2019, 1, 1, hh, mm, ss);
                      groupA.list.push(v);
                    }
                  });
                }
              });

              tmp404 += z.during;
              durings.push(z.during);
              const h = parseInt(tmp404 / (60 * 60));
              const m = parseInt((tmp404 - 60 * 60 * h) / 60);
              const s = tmp404 - 60 * 60 * h - 60 * m;
              groupA.time = new Date(2019, 1, 1, h, m, s); // 년, 월, 일, 시, 분, 초
            }
          });
        });
      } else if (vm.lectureType === 0 && x.if_small_group === null) {
        // 유인강의 동시활성
        groupA.seq = false;
        if (x.list_ids.length > 1) {
          groupA.shuffle = true;
        } else {
          groupA.shuffle = false;
        }

        x.list_ids.forEach((y) => {
          seq.data.forEach((z) => {
            if (parseInt(y, 10) === z.lecture_item_list_id) {
              // 연결리스트 아이템이 여러개라면 - 그룹 내 셔플
              if (z.linked_list.includes("<$!<>")) {
                const spl = z.linked_list.split("<$!<>");
                spl.forEach((w) => {
                  // 연결리스트에 속하는 각 아이템에 대해
                  itemList.forEach((v) => {
                    if (parseInt(w, 10) === v.lecture_item_id) {
                      v.ifGroup = true; // eslint-disable-line
                      v.during = 0;
                      v.duringTime = new Date(2019, 1, 1, 0, 0, 0);
                      groupA.list.push(v);
                    }
                  });
                });
              } else {
                // 연결리스트 아이템이 한 개 - 순서 고정
                itemList.forEach((v) => {
                  if (parseInt(z.linked_list, 10) === v.lecture_item_id) {
                    v.ifGroup = true; // eslint-disable-line
                    v.during = 0;
                    groupA.list.push(v);
                  }
                });
              }
            }
          });
        });
      } else {
        if (vm.lectureType !== 0 || vm.testMode === true) {
          // 무인강의 그룹 시간 받아오기
          groupA.time = new Date(2019, 1, 1, 0, 0, x.end - x.start);
        }
        x.list_ids.forEach((y) => {
          seq.data.forEach((z) => {
            if (parseInt(y, 10) === z.lecture_item_list_id) {
              // 연결리스트 아이템이 여러개라면 - 순서 고정
              if (z.linked_list.includes("<$!<>")) {
                groupA.shuffle = false;
                const spl = z.linked_list.split("<$!<>");
                spl.forEach((w) => {
                  // 연결리스트에 속하는 각 아이템에 대해
                  itemList.forEach((v) => {
                    if (parseInt(w, 10) === v.lecture_item_id) {
                      v.ifGroup = true; // eslint-disable-line
                      groupA.list.push(v);
                    }
                  });
                });
              } else {
                // 연결리스트 아이템이 한 개 - 고정 X
                groupA.shuffle = true;
                itemList.forEach((v) => {
                  if (parseInt(z.linked_list, 10) === v.lecture_item_id) {
                    v.ifGroup = true; // eslint-disable-line
                    groupA.list.push(v);
                  }
                });
              }
            }
          });
        });
      }
      vm.itemGroup.push(
        groupA
      );
      // TODO: savedShuffleGroup에도 같은거 만들기
    });
    // 그룹에 포함 안 된 아이템들
    itemList.forEach((x) => {
      if (x.ifGroup === false) {
        vm.noItemGroup.push(x);
      }
    });
    // 개인화 문항 수정
    vm.noItemGroup = vm.noItemGroup.filter((item) => item.type !== 7);
    // vm.renewal();
  },

  computed: {
    lectureId() {
      const vm = this;
      return Number.parseInt(vm.$route.query.lectureId, 10);
    },
  },
  methods: {
    ...mapMutations("lectureEditTab", ["updateTab"]),
    // 그룹 초기화
    resetGroup(index) {
      const vm = this;
      // 일단 그룹 내 아이템들을 모두 미지정으로
      vm.itemGroup[index].list.forEach((x, i) => {
        vm.noItemGroup.push(x); // 데이터 삽입
      });
      // 그룹 자체를 삭제
      vm.itemGroup.splice(index, 1);
    },
    // 아이템 드래그
    dragStart(item, index, index2) {
      // 아이템 드래그 시작
      const vm = this;
      vm.originGroup = index;
      vm.originNum = index2;
      vm.moveItem = vm.itemGroup[index].list[index2];
      vm.ifDragStart = true;
    },
    goBack() {
      const vm = this;
      vm.updateTab({
        tab: "item",
      });
      window.history.back();
    },
    drop(index, index2) {
      // 아이템 드롭
      const vm = this;
      if (
        vm.originGroup > -1 &&
        vm.itemGroup[vm.originGroup].shuffle !== undefined
      ) {
        if (vm.originGroup >= 0) {
          // 다른 아이템 그룹에서 가져온 경우
          vm.itemGroup[vm.originGroup].list.splice(vm.originNum, 1); // 원래 있던 위치에서 제거
        } else {
          // 그룹 미지정에서 가져온 경우
          vm.noItemGroup.splice(vm.originNum, 1);
        }
        const tmpList = [];
        for (let i = index2; i < vm.itemGroup[index].list.length; i += 1) {
          tmpList.push(vm.itemGroup[index].list[i]);
        }
        // 기존 데이터들 삭제
        vm.itemGroup[index].list.splice(
          index2,
          vm.itemGroup[index].list.length - index2
        );
        vm.itemGroup[index].list.push(vm.moveItem); // 옮겨 올 데이터 삽입
        tmpList.forEach((x) => {
          vm.itemGroup[index].list.push(x); // 기존 데이터 다시 넣기
        });
        if (vm.originGroup >= 0) {
          if (vm.itemGroup[vm.originGroup].list.length === 0) {
            // 원래 그룹 데이터 안 남았다면 그룹 삭제
            vm.itemGroup.splice(vm.originGroup, 1);
          }
        }
      } else {
        if (vm.originGroup >= 0) {
          // 다른 아이템 그룹에서 가져온 경우
          vm.itemGroup[vm.originGroup].list.splice(vm.originNum, 1); // 원래 있던 위치에서 제거
        } else {
          // 그룹 미지정에서 가져온 경우
          vm.noItemGroup.splice(vm.originNum, 1);
        }
        const tmpList = [];
        for (let i = index2; i < vm.itemGroup[index].list.length; i += 1) {
          tmpList.push(vm.itemGroup[index].list[i]);
        }
        // 기존 데이터들 삭제
        vm.itemGroup[index].list.splice(
          index2,
          vm.itemGroup[index].list.length - index2
        );
        vm.itemGroup[index].list.push(vm.moveItem); // 옮겨 올 데이터 삽입
        tmpList.forEach((x) => {
          vm.itemGroup[index].list.push(x); // 기존 데이터 다시 넣기
        });
        if (vm.originGroup >= 0) {
          if (vm.itemGroup[vm.originGroup].list.length === 0) {
            // 원래 그룹 데이터 안 남았다면 그룹 삭제
            vm.itemGroup.splice(vm.originGroup, 1);
          }
        }
      }
    },
    dragEnd() {
      // 아이템 드래그 종료
      const vm = this;
      vm.originGroup = -1;
      vm.originNum = -1;
      vm.moveItem = null;
      vm.ifDragStart = false;
    },
    newGroup() {
      // 아이템을 새로운 그룹으로
      const vm = this;
      if (vm.originGroup >= 0) {
        // 새로운 그룹에서 가져온 경우
        vm.itemGroup[vm.originGroup].list.splice(vm.originNum, 1); // 원래 있던 위치에서 제거
      } else {
        // 그룹 미지정에서 가져온 경우
        vm.noItemGroup.splice(vm.originNum, 1);
      }
      const tmp = {};
      tmp.list = [];
      tmp.shuffle = true;
      tmp.seq = false;
      if (vm.lectureType !== 0) {
        // 무인강의 그룹 시간 받아오기
        tmp.time = new Date(2019, 1, 1, 0, 0, 0);
      }
      tmp.list.push(vm.moveItem);
      vm.itemGroup.push(tmp); // 데이터 삽입
      vm.itemGroup[vm.itemGroup.length - 1].shuffle = false;
      if (vm.originGroup >= 0) {
        if (vm.itemGroup[vm.originGroup].list.length === 0) {
          // 원래 그룹 데이터 안 남았다면 그룹 삭제
          vm.itemGroup.splice(vm.originGroup, 1);
        }
      }
    },
    dragStartFromNo(index) {
      // 그룹 미지정에서 드래그 시작
      const vm = this;
      vm.originGroup = -2; // 그룹 미지정
      vm.originNum = index;
      vm.moveItem = vm.noItemGroup[index];
      vm.ifDragStart = true;
    },
    dropToNo() {
      // 그룹 미지정으로 드래그
      const vm = this;
      if (vm.originGroup >= 0) {
        // 다른 아이템 그룹에서 가져왔다면
        vm.itemGroup[vm.originGroup].list.splice(vm.originNum, 1); // 원래 있던 위치에서 제거
        vm.noItemGroup.push(vm.moveItem); // 데이터 삽입
        if (vm.itemGroup[vm.originGroup].list.length === 0) {
          // 원래 그룹 데이터 안 남았다면 그룹 삭제
          vm.itemGroup.splice(vm.originGroup, 1);
        }
      }
    },
    // 그룹 드래그
    dragStartGroup(index) {
      // 그룹 드래그 시작
      const vm = this;
      if (vm.ifDragStart === true) {
        return;
      }
      vm.dragGroup = index;
    },
    dragEndGroup() {
      const vm = this;
      vm.dragGroup = -1;
    },
    dropGroup(index) {
      const vm = this;
      if (vm.ifDragStart === true) {
        return;
      }
      const fromGroup = vm.itemGroup[vm.dragGroup];
      vm.itemGroup.splice(vm.dragGroup, 1); // 드래그한 그룹 제거
      const tmpList = [];
      for (let i = index; i < vm.itemGroup.length; i += 1) {
        tmpList.push(vm.itemGroup[i]);
      }
      vm.itemGroup.splice(index, vm.itemGroup.length - index); // 기존 그룹들 제거
      vm.itemGroup.push(fromGroup); // 드래그한 그룹 넣기
      tmpList.forEach((x) => {
        vm.itemGroup.push(x); // 기존 그룹들 다시 넣기
      });
    },
    async submitSetting() {
      // 설정 완료 클릭버튼
      const vm = this;
      let shuffleFlag = false; // 유인강의에서 아이템 그룹들 중 하나라도 순차활성이 있으면 true, 다 동시활성이면 false
      for (let i = 0; i < vm.itemGroup.length; i++) {
        if (vm.itemGroup[i].seq) shuffleFlag = true;
      }

      ////////////////////////////////////////////////// 유인 강의 동시 활성 ////////////////////////////////////////////////////////

      if (vm.lectureType === 0 && !shuffleFlag) {
        // 전부 유인강의 동시 활성일 경우
        // 모든 아이템 그룹 해제
        const grp = await lectureItemService.showGroup({
          lectureId: vm.lectureId,
        });
        for (let i = 0; i < grp.data.list.length; i += 1) {
          const x = grp.data.list[i];
          await lectureItemService.deleteGroup({
            // eslint-disable-line
            groupId: x.group_id,
          });
        }
        // 모든 아이템 리스트 해제
        const seq = await lectureItemService.showConnection({
          lectureId: vm.lectureId,
        });
        for (let i = 0; i < seq.data.length; i += 1) {
          const x = seq.data[i];
          await lectureItemService.deleteConnection({
            // eslint-disable-line
            lectureItemId: x.item_id,
          });
        }
        // 모든 아이템 소그룹 해제, 이후 소그룹 생성 X - 김성민
        const smg = await lectureItemService.showSmallGroup({
          lectureId: vm.lectureId,
        });
        for (let i = 0; i < smg.data.group.length; i += 1) {
          const x = smg.data.group[i].lecture_item_small_group_id;
          await lectureItemService.deleteSmallGroup({
            smallGroupId: x,
          });
        }
        // 아이템 그룹 하나씩 보면서 다시 연결
        for (let i = 0; i < vm.itemGroup.length; i += 1) {
          const x = vm.itemGroup[i];
          if (x.shuffle === false) {
            // 순서 고정인 경우 - 리스트 하나로
            const tmp = [];
            // 아이템을 다 tmp에 넣어서
            for (let j = 0; j < x.list.length; j += 1) {
              const y = x.list[j];
              tmp.push(y.lecture_item_id);
            }
            // 리스트 생성
            const newList = await lectureItemService.makeConnection({
              // eslint-disable-line
              lectureId: vm.lectureId,
              iList: tmp,
            });
            // 리스트 id로 그룹 생성
            const tmp2 = [];
            tmp2.push(newList.data.lecture_item_list_id);
            await lectureItemService.makeGroupNo({
              // eslint-disable-line
              lectureId: vm.lectureId,
              iList: tmp2,
            });
          }

          // TODO: 위가 유인 강의 + 셔플 없는 경우이기 때문에 괜춘할듯...?
          else {
            // 순서 고정이 아닌 경우 - 리스트 여러 개로
            const tmp2 = [];
            // 아이템 하나씩 리스트 생성
            for (let j = 0; j < x.list.length; j += 1) {
              const y = x.list[j];
              const tmp = [];
              tmp.push(y.lecture_item_id);
              const newList = await lectureItemService.makeConnection({
                // eslint-disable-line
                lectureId: vm.lectureId,
                iList: tmp,
              });
              // 리스트 id들을 tmp2에 넣음
              tmp2.push(newList.data.lecture_item_list_id);
            }
            // 그룹 생성
            await lectureItemService.makeGroupNo({
              // eslint-disable-line
              lectureId: vm.lectureId,
              iList: tmp2,
            });
          }
        }
        // 아이템 설정 성공 메시지 출력
        vm.$notify({
          title: vm.$t("NOTIFY.TITLE"),
          message: vm.$t("NOTIFY.COMP_ORDER_SET"),
          type: "success",
        });

        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        ////////////////////////////////////////// 유인 강의 순차 활성 //////////////////////////////////////////////////////////////////////
      } else if (vm.lectureType === 0 && shuffleFlag) {
        // 유인강의인데 순차 활성인 그룹이 하나라도 있는 경우 (동시+순차 섞인 경우도 포함)
        let allTimeSetting = true;
        // 순차 활성 그룹 중에 시간 설정 안 된 아이템 있는지
        vm.itemGroup.forEach((x) => {
          if (x.seq === true) {
            x.list.forEach((r) => {
              if (
                r.duringTime === null ||
                r.duringTime === undefined ||
                r.duringTime.getTime() / 1000 - 1548946800 === 0
              ) {
                // 1548946800 유닉스 타임스탬프
                allTimeSetting = false;
                vm.$notify({
                  title: vm.$t("NOTIFY.TITLE"),
                  message: vm.$t("ITEM.ITEM_ORD_NOT_TIME"),
                  type: "warning",
                });
              }
            });
          }
        });
        if (!allTimeSetting) {
          // 시간 설정 안 된 아이템 있음
          vm.$notify({
            title: vm.$t("NOTIFY.TITLE"),
            message: vm.$t("NOTIFY.GRP_TIME_SET"),
            type: "warning",
          });
        } else {
          // 시간 설정 안 된 아이템 없다면 정상 진행
          // 모든 아이템 그룹 해제
          const grp = await lectureItemService.showGroup({
            // eslint-disable-line
            lectureId: vm.lectureId,
          });
          for (let i = 0; i < grp.data.list.length; i += 1) {
            const x = grp.data.list[i];
            await lectureItemService.deleteGroup({
              // eslint-disable-line
              groupId: x.group_id,
            });
          }
          // 모든 아이템 리스트 해제
          const seq = await lectureItemService.showConnection({
            lectureId: vm.lectureId,
          });
          for (let i = 0; i < seq.data.length; i += 1) {
            const x = seq.data[i];
            await lectureItemService.deleteConnection({
              // eslint-disable-line
              lectureItemId: x.item_id,
            });
          }
          // 모든 아이템 소그룹 해제, 이후 소그룹 생성 O - 김성민
          const smg = await lectureItemService.showSmallGroup({
            lectureId: vm.lectureId,
          });
          for (let i = 0; i < smg.data.group.length; i += 1) {
            const x = smg.data.group[i].lecture_item_small_group_id;
            await lectureItemService.deleteSmallGroup({
              smallGroupId: x,
            });
          }
          // 아이템 그룹 하나씩 보면서 다시 연결
          let totalTime = 0;
          for (let i = 0; i < vm.itemGroup.length; i += 1) {
            const x = vm.itemGroup[i];
            if (x.seq === false) {
              // 유인강의 셔플링 그룹 아닌 경우 (동시 활성)
              const tmp = [];
              if (x.shuffle === true) {
                // 동시 활성인데 순서 셔플인 경우
                const tmp2 = [];
                // 아이템 하나씩 리스트 생성
                for (let j = 0; j < x.list.length; j += 1) {
                  const y = x.list[j];
                  const tmp = [];
                  tmp.push(y.lecture_item_id);
                  const newList = await lectureItemService.makeConnection({
                    // eslint-disable-line
                    lectureId: vm.lectureId,
                    iList: tmp,
                  });
                  // 리스트 id들을 tmp2에 넣음
                  tmp2.push(newList.data.lecture_item_list_id);
                }
                // 그룹 생성
                // makeGroupNo로 수정해야 함
                await lectureItemService.makeGroup({
                  // eslint-disable-line
                  lectureId: vm.lectureId,
                  iList: tmp2,
                  start: 0,
                  end: 0,
                });
              } else {
                // 순서 고정인 경우
                // 아이템을 다 tmp에 넣어서
                for (let j = 0; j < x.list.length; j += 1) {
                  const y = x.list[j];
                  tmp.push(y.lecture_item_id);
                }
                // 리스트 생성
                const newList = await lectureItemService.makeConnection({
                  // eslint-disable-line
                  lectureId: vm.lectureId,
                  iList: tmp,
                });
                // 리스트 id로 그룹 생성
                // makeGroupNo로 수정해야 함
                const tmp2 = [];
                tmp2.push(newList.data.lecture_item_list_id);
                await lectureItemService.makeGroup({
                  // eslint-disable-line
                  lectureId: vm.lectureId,
                  iList: tmp2,
                  start: 0,
                  end: 0,
                });
              }
            } else {
              // 유인강의 셔플링 그룹인 경우 (순차 활성)
              const tmp2 = [];
              let timeSum = 0;
              // 아이템 하나씩 리스트 생성
              for (let j = 0; j < x.list.length; j += 1) {
                const y = x.list[j];
                const tmp = [];
                tmp.push(y.lecture_item_id);
                const newList = await lectureItemService.makeConnection({
                  // eslint-disable-line
                  lectureId: vm.lectureId,
                  iList: tmp,
                });
                // 리스트 id들을 tmp2에 넣음
                const tmp2Match = {};
                tmp2Match.item_id = y.lecture_item_id;
                tmp2Match.list_id = newList.data.lecture_item_list_id;
                tmp2.push(tmp2Match);
              }
              // 소그룹 생성
              const tmp4 = [];
              for (let j = 0; j < x.list.length; j += 1) {
                let endTime2 =
                  (x.list[j].duringTime.getTime() / 1000 - 1548946800) %
                  (60 * 60 * 24);
                if (endTime2 < 0) {
                  endTime2 += 86400;
                }
                timeSum += endTime2;
                const tmp3 = [];
                // 이제 소그룹은 하나씩만 묶임 200611
                const iId = x.list[j].lecture_item_id;
                let lId;
                tmp2.forEach((q) => {
                  if (q.item_id === iId) {
                    lId = q.list_id;
                  }
                });
                tmp3.push(lId);
                const sId = await lectureItemService.makeSmallGroup({
                  // eslint-disable-line
                  lectureId: vm.lectureId,
                  iList: tmp3,
                  during: endTime2,
                });
                tmp4.push(sId.data.lecture_item_small_group_id);
              }
              let ifShuffle;
              if (x.shuffle === true) {
                ifShuffle = 1;
              } else if (x.shuffle === false) {
                ifShuffle = 2;
              }

              // 소그룹 아이디 넣어서 그룹 생성
              // const endTime = totalTime + (((x.list[j].duringTime.getTime() / 1000) - 1548946800) % (60 * 60 * 24));
              await lectureItemService.makeGroup2({
                // eslint-disable-line
                lectureId: vm.lectureId,
                iList: tmp4,
                start: 0,
                end: timeSum,
                ifSmallGroup: ifShuffle,
              });
            }
          }
          // 아이템 설정 성공 메시지 출력
          vm.$notify({
            title: vm.$t("NOTIFY.TITLE"),
            message: vm.$t("ITEM.ITEM_ORD_SUCC"),
            type: "success",
          });
        }
      }

      ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

      /////////////////////////////////////////////// 무인강의 //////////////////////////////////////////////////////////////
      else {
        // 무인강의일 경우 - 시간 설정 필요
        let allTimeSetting = true;
        vm.itemGroup.forEach((x) => {
          if (x.time === undefined || x.time === null) {
            vm.$notify({
              title: vm.$t("NOTIFY.TITLE"),
              message: vm.$t("ITEM.ITEM_ORD_NOT_TIME"),
              type: "warning",
            });
          }
          if (x.time.getTime() / 1000 - 1548946800 === 0) {
            allTimeSetting = false;
          }
        });
        if (!allTimeSetting) {
          // 시간 설정 안 된 그룹 있음
          vm.$notify({
            title: vm.$t("NOTIFY.TITLE"),
            message: vm.$t("NOTIFY.GRP_TIME_SET"),
            type: "warning",
          });
        } else {
          // 시험모드인지 판별
          if (vm.testMode === true) {
            await lectureService.changeTestMode({
              lectureId: vm.lectureId,
              test: 1,
            });
          } else {
            await lectureService.changeTestMode({
              lectureId: vm.lectureId,
              test: 0,
            });
          }
          // 모든 아이템 그룹 해제
          const grp = await lectureItemService.showGroup({
            // eslint-disable-line
            lectureId: vm.lectureId,
          });
          for (let i = 0; i < grp.data.list.length; i += 1) {
            const x = grp.data.list[i];
            await lectureItemService.deleteGroup({
              // eslint-disable-line
              groupId: x.group_id,
            });
          }
          // 모든 아이템 리스트 해제
          const seq = await lectureItemService.showConnection({
            lectureId: vm.lectureId,
          });
          for (let i = 0; i < seq.data.length; i += 1) {
            const x = seq.data[i];
            await lectureItemService.deleteConnection({
              // eslint-disable-line
              lectureItemId: x.item_id,
            });
          }
          // 모든 아이템 소그룹 해제, 이후 소그룹 생성 X - 김성민
          const smg = await lectureItemService.showSmallGroup({
            lectureId: vm.lectureId,
          });
          for (let i = 0; i < smg.data.group.length; i += 1) {
            const x = smg.data.group[i].lecture_item_small_group_id;
            await lectureItemService.deleteSmallGroup({
              smallGroupId: x,
            });
          }
          // 아이템 그룹 하나씩 보면서 다시 연결
          let totalTime = 0;
          for (let i = 0; i < vm.itemGroup.length; i += 1) {
            const x = vm.itemGroup[i];
            if (x.shuffle === false) {
              // 순서 고정인 경우 - 리스트 하나로
              const tmp = [];
              // 아이템을 다 tmp에 넣어서
              for (let j = 0; j < x.list.length; j += 1) {
                const y = x.list[j];
                tmp.push(y.lecture_item_id);
              }
              // 리스트 생성
              const newList = await lectureItemService.makeConnection({
                // eslint-disable-line
                lectureId: vm.lectureId,
                iList: tmp,
              });
              // 리스트 id로 그룹 생성
              const tmp2 = [];
              // 아이템 그룹 시간 맥스 단위는 24시간이라고 가정 - mod 값 이용
              const endTime =
                totalTime +
                ((x.time.getTime() / 1000 - 1548946800) % (60 * 60 * 24));
              tmp2.push(newList.data.lecture_item_list_id);
              await lectureItemService.makeGroup({
                // eslint-disable-line
                lectureId: vm.lectureId,
                iList: tmp2,
                start: totalTime,
                end: endTime,
              });
              totalTime = endTime + 1;
            } else {
              // 순서 고정이 아닌 경우 - 리스트 여러 개로
              const tmp2 = [];
              // 아이템 하나씩 리스트 생성
              for (let j = 0; j < x.list.length; j += 1) {
                const y = x.list[j];
                const tmp = [];
                tmp.push(y.lecture_item_id);
                const newList = await lectureItemService.makeConnection({
                  // eslint-disable-line
                  lectureId: vm.lectureId,
                  iList: tmp,
                });
                // 리스트 id들을 tmp2에 넣음
                tmp2.push(newList.data.lecture_item_list_id);
              }
              // 그룹 생성
              const endTime =
                totalTime +
                ((x.time.getTime() / 1000 - 1548946800) % (60 * 60 * 24));
              await lectureItemService.makeGroup({
                // eslint-disable-line
                lectureId: vm.lectureId,
                iList: tmp2,
                start: totalTime,
                end: endTime,
              });
              totalTime = endTime + 1;
            }
          }
          // 아이템 설정 성공 메시지 출력
          vm.$notify({
            title: vm.$t("NOTIFY.TITLE"),
            message: vm.$t("NOTIFY.COMP_ORDER_SET"),
            type: "success",
          });
        }
      }
    },
  },
};
</script>


<!-- css -->
<style>
.itemBoard {
  overflow-x: auto;
  white-space: nowrap;
  overflow-y: hidden;
  min-height: 1px;
}

.noItemBoard {
  float: right;
}

.groupList {
  list-style-type: none;
  padding: 10px;
  float: left;
  margin: 5px;
  /* width: 338px; */
  background-color: #cfc9eb;
}

.smallGroupList {
  list-style-type: none;
  padding: 10px;
  float: left;
  margin: 5px;
  background-color: #e0dcf2;
}

.noGroupList {
  list-style-type: none;
  padding: 10px;
  float: left;
  margin: 10px;
  background-color: #ffde72;
  width: 200px;
}

.shuffleNoGroupList {
  list-style-type: none;
  padding: 10px;
  float: left;
  margin: 10px;
  background-color: #ffe798;
  width: 200px;
}

.itemList {
  border: 1px solid #ccc;
  padding: 14px 8px;
  margin-bottom: 3px;
  background-color: #ffffff;
  box-shadow: 1px 2px 2px #ccc;
  font-size: 15px;
  width: 180px;
}

.semiItemList {
  border: 1px solid #ccc;
  border-radius: 30px;
  padding: 14px 8px;
  margin-bottom: 3px;
  background-color: #faffff;
  box-shadow: 1px 2px 2px #ccc;
  font-size: 15px;
  width: 180px;
}

.groupButton {
  margin: 5px;
}
</style>